c       cxyz2det:  xyz to det
c       cdet2xyz:  det to xyz
c       cxyz2detD: xyz to det for Direction cos.
c       cdet2xyzD: det to xyz for Direction cos.
c
      subroutine cxyz2det(det, a, b)
c          convert coord value in the "xyz" system into "det" system.
c        det: /coord/  input. detector coord in "xyz"
c          a: /coord/  input. coord in 'xyz'
c          b: /coord/  outupt. coord in 'det'
c
      implicit none

#include  "Zcoord.h"
#include  "Zobs.h"
#include  "Zpos.h"
#include  "Zmagfield.h"
#include  "Zobsv.h"

      record /coord/ a, b, det

c      record /coord/ tempa
      real(8):: temp(3)
      temp(:) = a.r(:) - det.r(:)
      b.r(:) = matmul( Txyz2det(:,:), temp(:))
      b.sys = 'det'
c      real*8 leng
c       coord in "xyz"   from the origin of det.

c       tempa.r(1) = a.r(1) -  det.r(1)
c       tempa.r(2) = a.r(2) -  det.r(2)
c       tempa.r(3) = a.r(3) -  det.r(3)
c          make it direction cos.
c       call c3DV2DDCos(tempa, tempa, leng)
c          maket it direction cos in "det" system.
c       call ciTransVectZx(1, DetZaxis, DetXaxis, tempa, b)
c          to 3D vectors
c      
c       b.r(1) = b.r(1) *leng
c       b.r(2) = b.r(2) *leng
c       b.r(3) = b.r(3) *leng
c       b.sys = 'det'
       end
c      *******************************
       subroutine cdet2xyz(det, a, b)
c      *******************************
       implicit none

#include  "Zcoord.h"
#include  "Zobs.h"
#include  "Zpos.h"
#include  "Zmagfield.h"
#include  "Zobsv.h"

c              
        record /coord/ a, b, det
        real(8)::temp(3)
        temp(:) = matmul( Tdet2xyz(:,:), a.r(:))
        b.r(:) = temp(:) + det.r(:)
        b.sys = 'xyz'
c        record /coord/ tempa
c        real*8 leng
c           to direction cos in 'det'
c        call c3DV2DDCos(a, tempa, leng)
c           to direction cos in 'zyz'
c        call ctransVectZx(1, DetZaxis, DetXaxis,tempa, b)
c           to xyz sys
c        b.r(1) = b.r(1) *leng + det.r(1)
c        b.r(2) = b.r(2) *leng + det.r(2)
c        b.r(3) = b.r(3) *leng + det.r(3)
c        b.sys = 'xyz'
        end
c      -----------------------------------
        subroutine  cxyz2detD(a, b)
       implicit none

#include  "Zcoord.h"
#include  "Zobs.h"
#include  "Zpos.h"
#include  "Zmagfield.h"
#include  "Zobsv.h"


c              
       record /coord/ a, b
       real::temp(3)
       temp(:) =matmul(Txyz2det(:,:), a.r(:)) 
       b.r(:) = temp(:)
       b.sys = 'det'
c       call ciTransVectZx(1, DetZaxis, DetXaxis, a, b)
c       b.sys = 'det'
       end
c      -----------------------------------------------------
       subroutine cdet2xyzD(a, b)
       implicit none
#include  "Zcoord.h"
#include  "Zobs.h"
#include  "Zpos.h"
#include  "Zmagfield.h"
#include  "Zobsv.h"

        record /coord/ a, b
        real(8):: temp(3)
        temp(:) = matmul( Tdet2xyz(:,:), a.r(:))
        b.r(:) = temp(:)
c        call ctransVectZx(1, DetZaxis, DetXaxis, a, b)       
        end
